//! Preset colors for both categorical and numerical palettes.

use crate::{LinearGradient, Preset};
use palette::Srgba;

/// Categorical presets.
#[derive(Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "serde", derive(serde::Serialize, serde::Deserialize))]
#[cfg_attr(
    feature = "strum",
    derive(
        strum::EnumString,
        strum::Display,
        strum::FromRepr,
        strum::AsRefStr,
        strum::VariantNames,
        strum::EnumIter
    )
)]
pub enum Categorical {
    #[default]
    Plotly,
    D3,
    G10,
    T10,
    Alphabet,
    Dark24,
    Light24,
    Set1,
    Pastel1,
    Dark2,
    Set2,
    Pastel2,
    Set3,
    Antique,
    Bold,
    Pastel,
    Prism,
    Safe,
    Vivid,
}
impl Preset for Categorical {
    type Value = Srgba<u8>;
    fn values(&self) -> Vec<Self::Value> {
        let rgbas: &[(u8, u8, u8, u8)] = match self {
            Self::Plotly => &CAT_PLOTLY,
            Self::D3 => &CAT_D3,
            Self::G10 => &CAT_G10,
            Self::T10 => &CAT_T10,
            Self::Alphabet => &CAT_ALPHABET,
            Self::Dark24 => &CAT_DARK24,
            Self::Light24 => &CAT_LIGHT24,
            Self::Set1 => &CAT_SET1,
            Self::Pastel1 => &CAT_PASTEL1,
            Self::Dark2 => &CAT_DARK2,
            Self::Set2 => &CAT_SET2,
            Self::Pastel2 => &CAT_PASTEL2,
            Self::Set3 => &CAT_SET3,
            Self::Antique => &CAT_ANTIQUE,
            Self::Bold => &CAT_BOLD,
            Self::Pastel => &CAT_PASTEL,
            Self::Prism => &CAT_PRISM,
            Self::Safe => &CAT_SAFE,
            Self::Vivid => &CAT_VIVID,
        };
        rgbas
            .iter()
            .map(|&(r, g, b, a)| Srgba::new(r, g, b, a))
            .collect()
    }
}

/// Numerical presets.
#[derive(Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "serde", derive(serde::Serialize, serde::Deserialize))]
#[cfg_attr(
    feature = "strum",
    derive(
        strum::EnumString,
        strum::Display,
        strum::FromRepr,
        strum::AsRefStr,
        strum::VariantNames,
        strum::EnumIter
    )
)]
pub enum Numerical {
    #[default]
    Ratio,
    CycTwilight,
    CycIceFire,
    CycEdge,
    CycPhase,
    CycHSV,
    CycMrybm,
    CycMygbm,
    DivBrBG,
    DivPRGn,
    DivPiYG,
    DivPuOr,
    DivRdBu,
    DivRdGy,
    DivRdYlBu,
    DivRdYlGn,
    DivSpectral,
    DivBalance,
    DivDelta,
    DivCurl,
    DivOxy,
    DivArmyrose,
    DivFall,
    DivGeyser,
    DivTemps,
    DivTealrose,
    DivTropic,
    DivEarth,
    DivPicnic,
    DivPortland,
    SeqPlotly3,
    SeqViridis,
    SeqCividis,
    SeqInferno,
    SeqMagma,
    SeqPlasma,
    SeqTurbo,
    SeqBlackbody,
    SeqBluered,
    SeqElectric,
    SeqHot,
    SeqJet,
    SeqRainbow,
    SeqBlues,
    SeqBuGn,
    SeqBuPu,
    SeqGnBu,
    SeqGreens,
    SeqGreys,
    SeqOrRd,
    SeqOranges,
    SeqPuBu,
    SeqPuBuGn,
    SeqPuRd,
    SeqPurples,
    SeqRdBu,
    SeqRdPu,
    SeqReds,
    SeqYlGn,
    SeqYlGnBu,
    SeqYlOrBr,
    SeqYlOrRd,
    SeqTurbid,
    SeqThermal,
    SeqHaline,
    SeqSolar,
    SeqIce,
    SeqGray,
    SeqDeep,
    SeqDense,
    SeqAlgae,
    SeqMatter,
    SeqSpeed,
    SeqAmp,
    SeqTempo,
    SeqBurg,
    SeqBurgyl,
    SeqRedor,
    SeqOryel,
    SeqPeach,
    SeqPinkyl,
    SeqMint,
    SeqBlugrn,
    SeqDarkmint,
    SeqEmrld,
    SeqAggrnyl,
    SeqBluyl,
    SeqTeal,
    SeqTealgrn,
    SeqPurp,
    SeqPurpor,
    SeqSunset,
    SeqMagenta,
    SeqSunsetdark,
    SeqAgsunset,
    SeqBrwnyl,
}
impl Numerical {
    /// The colors of the color scale in sequential order.
    fn colors(&self) -> Vec<Srgba<u8>> {
        let rgbas: &[(u8, u8, u8, u8)] = match self {
            Self::Ratio => &NUM_RATIO,
            Self::CycTwilight => &CYC_TWILIGHT,
            Self::CycIceFire => &CYC_ICEFIRE,
            Self::CycEdge => &CYC_EDGE,
            Self::CycPhase => &CYC_PHASE,
            Self::CycHSV => &CYC_HSV,
            Self::CycMrybm => &CYC_MRYBM,
            Self::CycMygbm => &CYC_MYGBM,
            Self::DivBrBG => &DIV_BRBG,
            Self::DivPRGn => &DIV_PRGN,
            Self::DivPiYG => &DIV_PIYG,
            Self::DivPuOr => &DIV_PUOR,
            Self::DivRdBu => &DIV_RDBU,
            Self::DivRdGy => &DIV_RDGY,
            Self::DivRdYlBu => &DIV_RDYLBU,
            Self::DivRdYlGn => &DIV_RDYLGN,
            Self::DivSpectral => &DIV_SPECTRAL,
            Self::DivBalance => &DIV_BALANCE,
            Self::DivDelta => &DIV_DELTA,
            Self::DivCurl => &DIV_CURL,
            Self::DivOxy => &DIV_OXY,
            Self::DivArmyrose => &DIV_ARMYROSE,
            Self::DivFall => &DIV_FALL,
            Self::DivGeyser => &DIV_GEYSER,
            Self::DivTemps => &DIV_TEMPS,
            Self::DivTealrose => &DIV_TEALROSE,
            Self::DivTropic => &DIV_TROPIC,
            Self::DivEarth => &DIV_EARTH,
            Self::DivPicnic => &DIV_PICNIC,
            Self::DivPortland => &DIV_PORTLAND,
            Self::SeqPlotly3 => &SEQ_PLOTLY3,
            Self::SeqViridis => &SEQ_VIRIDIS,
            Self::SeqCividis => &SEQ_CIVIDIS,
            Self::SeqInferno => &SEQ_INFERNO,
            Self::SeqMagma => &SEQ_MAGMA,
            Self::SeqPlasma => &SEQ_PLASMA,
            Self::SeqTurbo => &SEQ_TURBO,
            Self::SeqBlackbody => &SEQ_BLACKBODY,
            Self::SeqBluered => &SEQ_BLUERED,
            Self::SeqElectric => &SEQ_ELECTRIC,
            Self::SeqHot => &SEQ_HOT,
            Self::SeqJet => &SEQ_JET,
            Self::SeqRainbow => &SEQ_RAINBOW,
            Self::SeqBlues => &SEQ_BLUES,
            Self::SeqBuGn => &SEQ_BUGN,
            Self::SeqBuPu => &SEQ_BUPU,
            Self::SeqGnBu => &SEQ_GNBU,
            Self::SeqGreens => &SEQ_GREENS,
            Self::SeqGreys => &SEQ_GREYS,
            Self::SeqOrRd => &SEQ_ORRD,
            Self::SeqOranges => &SEQ_ORANGES,
            Self::SeqPuBu => &SEQ_PUBU,
            Self::SeqPuBuGn => &SEQ_PUBUGN,
            Self::SeqPuRd => &SEQ_PURD,
            Self::SeqPurples => &SEQ_PURPLES,
            Self::SeqRdBu => &SEQ_RDBU,
            Self::SeqRdPu => &SEQ_RDPU,
            Self::SeqReds => &SEQ_REDS,
            Self::SeqYlGn => &SEQ_YLGN,
            Self::SeqYlGnBu => &SEQ_YLGNBU,
            Self::SeqYlOrBr => &SEQ_YLORBR,
            Self::SeqYlOrRd => &SEQ_YLORRD,
            Self::SeqTurbid => &SEQ_TURBID,
            Self::SeqThermal => &SEQ_THERMAL,
            Self::SeqHaline => &SEQ_HALINE,
            Self::SeqSolar => &SEQ_SOLAR,
            Self::SeqIce => &SEQ_ICE,
            Self::SeqGray => &SEQ_GRAY,
            Self::SeqDeep => &SEQ_DEEP,
            Self::SeqDense => &SEQ_DENSE,
            Self::SeqAlgae => &SEQ_ALGAE,
            Self::SeqMatter => &SEQ_MATTER,
            Self::SeqSpeed => &SEQ_SPEED,
            Self::SeqAmp => &SEQ_AMP,
            Self::SeqTempo => &SEQ_TEMPO,
            Self::SeqBurg => &SEQ_BURG,
            Self::SeqBurgyl => &SEQ_BURGYL,
            Self::SeqRedor => &SEQ_REDOR,
            Self::SeqOryel => &SEQ_ORYEL,
            Self::SeqPeach => &SEQ_PEACH,
            Self::SeqPinkyl => &SEQ_PINKYL,
            Self::SeqMint => &SEQ_MINT,
            Self::SeqBlugrn => &SEQ_BLUGRN,
            Self::SeqDarkmint => &SEQ_DARKMINT,
            Self::SeqEmrld => &SEQ_EMRLD,
            Self::SeqAggrnyl => &SEQ_AGGRNYL,
            Self::SeqBluyl => &SEQ_BLUYL,
            Self::SeqTeal => &SEQ_TEAL,
            Self::SeqTealgrn => &SEQ_TEALGRN,
            Self::SeqPurp => &SEQ_PURP,
            Self::SeqPurpor => &SEQ_PURPOR,
            Self::SeqSunset => &SEQ_SUNSET,
            Self::SeqMagenta => &SEQ_MAGENTA,
            Self::SeqSunsetdark => &SEQ_SUNSETDARK,
            Self::SeqAgsunset => &SEQ_AGSUNSET,
            Self::SeqBrwnyl => &SEQ_BRWNYL,
        };
        rgbas
            .iter()
            .map(|&(r, g, b, a)| Srgba::new(r, g, b, a))
            .collect()
    }
}
impl From<&Numerical> for LinearGradient {
    fn from(value: &Numerical) -> Self {
        let colors = value.colors();
        LinearGradient::new(colors, None).expect("a valid preset")
    }
}
impl From<Numerical> for LinearGradient {
    fn from(value: Numerical) -> Self {
        let colors = value.colors();
        LinearGradient::new(colors, None).expect("a valid preset")
    }
}
impl Preset for Numerical {
    type Value = LinearGradient;
    fn values(&self) -> Vec<Self::Value> {
        vec![self.into()]
    }
}

/// Ratio numerical palette as RGBa tuples.
pub const NUM_RATIO: [(u8, u8, u8, u8); 9] = [
    (182, 234, 217, 255),
    (149, 217, 213, 255),
    (125, 194, 213, 255),
    (112, 165, 213, 255),
    (107, 134, 205, 255),
    (108, 102, 188, 255),
    (107, 73, 159, 255),
    (100, 48, 121, 255),
    (84, 29, 79, 255),
];

pub const CAT_PLOTLY: [(u8, u8, u8, u8); 10] = [
    (99, 110, 250, 255),
    (239, 85, 59, 255),
    (0, 204, 150, 255),
    (171, 99, 250, 255),
    (255, 161, 90, 255),
    (25, 211, 243, 255),
    (255, 102, 146, 255),
    (182, 232, 128, 255),
    (255, 151, 255, 255),
    (254, 203, 82, 255),
];
pub const CAT_D3: [(u8, u8, u8, u8); 10] = [
    (31, 119, 180, 255),
    (255, 127, 14, 255),
    (44, 160, 44, 255),
    (214, 39, 40, 255),
    (148, 103, 189, 255),
    (140, 86, 75, 255),
    (227, 119, 194, 255),
    (127, 127, 127, 255),
    (188, 189, 34, 255),
    (23, 190, 207, 255),
];
pub const CAT_G10: [(u8, u8, u8, u8); 10] = [
    (51, 102, 204, 255),
    (220, 57, 18, 255),
    (255, 153, 0, 255),
    (16, 150, 24, 255),
    (153, 0, 153, 255),
    (0, 153, 198, 255),
    (221, 68, 119, 255),
    (102, 170, 0, 255),
    (184, 46, 46, 255),
    (49, 99, 149, 255),
];
pub const CAT_T10: [(u8, u8, u8, u8); 10] = [
    (76, 120, 168, 255),
    (245, 133, 24, 255),
    (228, 87, 86, 255),
    (114, 183, 178, 255),
    (84, 162, 75, 255),
    (238, 202, 59, 255),
    (178, 121, 162, 255),
    (255, 157, 166, 255),
    (157, 117, 93, 255),
    (186, 176, 172, 255),
];
pub const CAT_ALPHABET: [(u8, u8, u8, u8); 26] = [
    (170, 13, 254, 255),
    (50, 131, 254, 255),
    (133, 102, 13, 255),
    (120, 42, 182, 255),
    (86, 86, 86, 255),
    (28, 131, 86, 255),
    (22, 255, 50, 255),
    (247, 225, 160, 255),
    (226, 226, 226, 255),
    (28, 190, 79, 255),
    (196, 69, 28, 255),
    (222, 160, 253, 255),
    (254, 0, 250, 255),
    (50, 90, 155, 255),
    (254, 175, 22, 255),
    (248, 161, 159, 255),
    (144, 173, 28, 255),
    (246, 34, 46, 255),
    (28, 255, 206, 255),
    (46, 217, 255, 255),
    (177, 13, 161, 255),
    (192, 117, 166, 255),
    (252, 28, 191, 255),
    (176, 0, 104, 255),
    (251, 228, 38, 255),
    (250, 0, 135, 255),
];
pub const CAT_DARK24: [(u8, u8, u8, u8); 24] = [
    (46, 145, 229, 255),
    (225, 95, 153, 255),
    (28, 167, 28, 255),
    (251, 13, 13, 255),
    (218, 22, 255, 255),
    (34, 42, 42, 255),
    (182, 129, 0, 255),
    (117, 13, 134, 255),
    (235, 102, 59, 255),
    (81, 28, 251, 255),
    (0, 160, 139, 255),
    (251, 0, 209, 255),
    (252, 0, 128, 255),
    (178, 130, 141, 255),
    (108, 124, 50, 255),
    (119, 138, 174, 255),
    (134, 42, 22, 255),
    (167, 119, 241, 255),
    (98, 0, 66, 255),
    (22, 22, 167, 255),
    (218, 96, 202, 255),
    (108, 69, 22, 255),
    (13, 42, 99, 255),
    (175, 0, 56, 255),
];
pub const CAT_LIGHT24: [(u8, u8, u8, u8); 24] = [
    (253, 50, 22, 255),
    (0, 254, 53, 255),
    (106, 118, 252, 255),
    (254, 212, 196, 255),
    (254, 0, 206, 255),
    (13, 249, 255, 255),
    (246, 249, 38, 255),
    (255, 150, 22, 255),
    (71, 155, 85, 255),
    (238, 166, 251, 255),
    (220, 88, 125, 255),
    (214, 38, 255, 255),
    (110, 137, 156, 255),
    (0, 181, 247, 255),
    (182, 142, 0, 255),
    (201, 251, 229, 255),
    (255, 0, 146, 255),
    (34, 255, 167, 255),
    (227, 238, 158, 255),
    (134, 206, 0, 255),
    (188, 113, 150, 255),
    (126, 125, 205, 255),
    (252, 105, 85, 255),
    (228, 143, 114, 255),
];
pub const CAT_SET1: [(u8, u8, u8, u8); 9] = [
    (228, 26, 28, 255),
    (55, 126, 184, 255),
    (77, 175, 74, 255),
    (152, 78, 163, 255),
    (255, 127, 0, 255),
    (255, 255, 51, 255),
    (166, 86, 40, 255),
    (247, 129, 191, 255),
    (153, 153, 153, 255),
];
pub const CAT_PASTEL1: [(u8, u8, u8, u8); 9] = [
    (251, 180, 174, 255),
    (179, 205, 227, 255),
    (204, 235, 197, 255),
    (222, 203, 228, 255),
    (254, 217, 166, 255),
    (255, 255, 204, 255),
    (229, 216, 189, 255),
    (253, 218, 236, 255),
    (242, 242, 242, 255),
];
pub const CAT_DARK2: [(u8, u8, u8, u8); 8] = [
    (27, 158, 119, 255),
    (217, 95, 2, 255),
    (117, 112, 179, 255),
    (231, 41, 138, 255),
    (102, 166, 30, 255),
    (230, 171, 2, 255),
    (166, 118, 29, 255),
    (102, 102, 102, 255),
];
pub const CAT_SET2: [(u8, u8, u8, u8); 8] = [
    (102, 194, 165, 255),
    (252, 141, 98, 255),
    (141, 160, 203, 255),
    (231, 138, 195, 255),
    (166, 216, 84, 255),
    (255, 217, 47, 255),
    (229, 196, 148, 255),
    (179, 179, 179, 255),
];
pub const CAT_PASTEL2: [(u8, u8, u8, u8); 8] = [
    (179, 226, 205, 255),
    (253, 205, 172, 255),
    (203, 213, 232, 255),
    (244, 202, 228, 255),
    (230, 245, 201, 255),
    (255, 242, 174, 255),
    (241, 226, 204, 255),
    (204, 204, 204, 255),
];
pub const CAT_SET3: [(u8, u8, u8, u8); 12] = [
    (141, 211, 199, 255),
    (255, 255, 179, 255),
    (190, 186, 218, 255),
    (251, 128, 114, 255),
    (128, 177, 211, 255),
    (253, 180, 98, 255),
    (179, 222, 105, 255),
    (252, 205, 229, 255),
    (217, 217, 217, 255),
    (188, 128, 189, 255),
    (204, 235, 197, 255),
    (255, 237, 111, 255),
];
pub const CAT_ANTIQUE: [(u8, u8, u8, u8); 11] = [
    (133, 92, 117, 255),
    (217, 175, 107, 255),
    (175, 100, 88, 255),
    (115, 111, 76, 255),
    (82, 106, 131, 255),
    (98, 83, 119, 255),
    (104, 133, 92, 255),
    (156, 156, 94, 255),
    (160, 97, 119, 255),
    (140, 120, 93, 255),
    (124, 124, 124, 255),
];
pub const CAT_BOLD: [(u8, u8, u8, u8); 11] = [
    (127, 60, 141, 255),
    (17, 165, 121, 255),
    (57, 105, 172, 255),
    (242, 183, 1, 255),
    (231, 63, 116, 255),
    (128, 186, 90, 255),
    (230, 131, 16, 255),
    (0, 134, 149, 255),
    (207, 28, 144, 255),
    (249, 123, 114, 255),
    (165, 170, 153, 255),
];
pub const CAT_PASTEL: [(u8, u8, u8, u8); 11] = [
    (102, 197, 204, 255),
    (246, 207, 113, 255),
    (248, 156, 116, 255),
    (220, 176, 242, 255),
    (135, 197, 95, 255),
    (158, 185, 243, 255),
    (254, 136, 177, 255),
    (201, 219, 116, 255),
    (139, 224, 164, 255),
    (180, 151, 231, 255),
    (179, 179, 179, 255),
];
pub const CAT_PRISM: [(u8, u8, u8, u8); 11] = [
    (95, 70, 144, 255),
    (29, 105, 150, 255),
    (56, 166, 165, 255),
    (15, 133, 84, 255),
    (115, 175, 72, 255),
    (237, 173, 8, 255),
    (225, 124, 5, 255),
    (204, 80, 62, 255),
    (148, 52, 110, 255),
    (111, 64, 112, 255),
    (102, 102, 102, 255),
];
pub const CAT_SAFE: [(u8, u8, u8, u8); 11] = [
    (136, 204, 238, 255),
    (204, 102, 119, 255),
    (221, 204, 119, 255),
    (17, 119, 51, 255),
    (51, 34, 136, 255),
    (170, 68, 153, 255),
    (68, 170, 153, 255),
    (153, 153, 51, 255),
    (136, 34, 85, 255),
    (102, 17, 0, 255),
    (136, 136, 136, 255),
];
pub const CAT_VIVID: [(u8, u8, u8, u8); 11] = [
    (229, 134, 6, 255),
    (93, 105, 177, 255),
    (82, 188, 163, 255),
    (153, 201, 69, 255),
    (204, 97, 176, 255),
    (36, 121, 108, 255),
    (218, 165, 27, 255),
    (47, 138, 196, 255),
    (118, 78, 159, 255),
    (237, 100, 90, 255),
    (165, 170, 153, 255),
];
pub const CYC_TWILIGHT: [(u8, u8, u8, u8); 10] = [
    (226, 217, 226, 255),
    (158, 187, 201, 255),
    (103, 133, 190, 255),
    (94, 67, 165, 255),
    (66, 18, 87, 255),
    (71, 19, 64, 255),
    (142, 44, 80, 255),
    (186, 102, 87, 255),
    (206, 172, 148, 255),
    (226, 217, 226, 255),
];
pub const CYC_ICEFIRE: [(u8, u8, u8, u8); 17] = [
    (0, 0, 0, 255),
    (0, 31, 77, 255),
    (0, 55, 134, 255),
    (14, 88, 168, 255),
    (33, 126, 184, 255),
    (48, 164, 202, 255),
    (84, 200, 223, 255),
    (155, 228, 239, 255),
    (225, 233, 209, 255),
    (243, 213, 115, 255),
    (231, 176, 0, 255),
    (218, 130, 0, 255),
    (198, 84, 0, 255),
    (172, 35, 1, 255),
    (130, 0, 0, 255),
    (76, 0, 0, 255),
    (0, 0, 0, 255),
];
pub const CYC_EDGE: [(u8, u8, u8, u8); 17] = [
    (49, 49, 49, 255),
    (61, 1, 157, 255),
    (56, 16, 220, 255),
    (45, 71, 249, 255),
    (37, 147, 255, 255),
    (42, 222, 246, 255),
    (96, 253, 250, 255),
    (174, 253, 255, 255),
    (243, 243, 241, 255),
    (255, 253, 169, 255),
    (250, 253, 91, 255),
    (247, 218, 41, 255),
    (255, 142, 37, 255),
    (248, 67, 45, 255),
    (217, 13, 57, 255),
    (151, 2, 61, 255),
    (49, 49, 49, 255),
];
pub const CYC_PHASE: [(u8, u8, u8, u8); 12] = [
    (167, 119, 12, 255),
    (197, 96, 51, 255),
    (217, 67, 96, 255),
    (221, 38, 163, 255),
    (196, 59, 224, 255),
    (153, 97, 244, 255),
    (95, 127, 228, 255),
    (40, 144, 183, 255),
    (15, 151, 136, 255),
    (39, 153, 79, 255),
    (119, 141, 17, 255),
    (167, 119, 12, 255),
];
pub const CYC_HSV: [(u8, u8, u8, u8); 10] = [
    (255, 0, 0, 255),
    (255, 167, 0, 255),
    (175, 255, 0, 255),
    (8, 255, 0, 255),
    (0, 255, 159, 255),
    (0, 183, 255, 255),
    (0, 16, 255, 255),
    (151, 0, 255, 255),
    (255, 0, 191, 255),
    (255, 0, 0, 255),
];
pub const CYC_MRYBM: [(u8, u8, u8, u8); 17] = [
    (248, 132, 247, 255),
    (249, 104, 196, 255),
    (234, 67, 136, 255),
    (207, 36, 75, 255),
    (181, 26, 21, 255),
    (189, 67, 4, 255),
    (204, 105, 4, 255),
    (213, 143, 4, 255),
    (207, 170, 39, 255),
    (161, 159, 98, 255),
    (88, 138, 147, 255),
    (34, 105, 196, 255),
    (62, 62, 240, 255),
    (107, 78, 249, 255),
    (149, 107, 250, 255),
    (205, 125, 254, 255),
    (248, 132, 247, 255),
];
pub const CYC_MYGBM: [(u8, u8, u8, u8); 17] = [
    (239, 85, 241, 255),
    (251, 132, 206, 255),
    (251, 175, 161, 255),
    (252, 212, 113, 255),
    (240, 237, 53, 255),
    (198, 229, 22, 255),
    (150, 211, 16, 255),
    (97, 193, 11, 255),
    (49, 172, 40, 255),
    (67, 144, 100, 255),
    (61, 113, 154, 255),
    (40, 78, 200, 255),
    (46, 33, 234, 255),
    (99, 36, 245, 255),
    (145, 57, 250, 255),
    (197, 67, 250, 255),
    (239, 85, 241, 255),
];
pub const DIV_BRBG: [(u8, u8, u8, u8); 11] = [
    (84, 48, 5, 255),
    (140, 81, 10, 255),
    (191, 129, 45, 255),
    (223, 194, 125, 255),
    (246, 232, 195, 255),
    (245, 245, 245, 255),
    (199, 234, 229, 255),
    (128, 205, 193, 255),
    (53, 151, 143, 255),
    (1, 102, 94, 255),
    (0, 60, 48, 255),
];
pub const DIV_PRGN: [(u8, u8, u8, u8); 11] = [
    (64, 0, 75, 255),
    (118, 42, 131, 255),
    (153, 112, 171, 255),
    (194, 165, 207, 255),
    (231, 212, 232, 255),
    (247, 247, 247, 255),
    (217, 240, 211, 255),
    (166, 219, 160, 255),
    (90, 174, 97, 255),
    (27, 120, 55, 255),
    (0, 68, 27, 255),
];
pub const DIV_PIYG: [(u8, u8, u8, u8); 11] = [
    (142, 1, 82, 255),
    (197, 27, 125, 255),
    (222, 119, 174, 255),
    (241, 182, 218, 255),
    (253, 224, 239, 255),
    (247, 247, 247, 255),
    (230, 245, 208, 255),
    (184, 225, 134, 255),
    (127, 188, 65, 255),
    (77, 146, 33, 255),
    (39, 100, 25, 255),
];
pub const DIV_PUOR: [(u8, u8, u8, u8); 11] = [
    (127, 59, 8, 255),
    (179, 88, 6, 255),
    (224, 130, 20, 255),
    (253, 184, 99, 255),
    (254, 224, 182, 255),
    (247, 247, 247, 255),
    (216, 218, 235, 255),
    (178, 171, 210, 255),
    (128, 115, 172, 255),
    (84, 39, 136, 255),
    (45, 0, 75, 255),
];
pub const DIV_RDBU: [(u8, u8, u8, u8); 11] = [
    (103, 0, 31, 255),
    (178, 24, 43, 255),
    (214, 96, 77, 255),
    (244, 165, 130, 255),
    (253, 219, 199, 255),
    (247, 247, 247, 255),
    (209, 229, 240, 255),
    (146, 197, 222, 255),
    (67, 147, 195, 255),
    (33, 102, 172, 255),
    (5, 48, 97, 255),
];
pub const DIV_RDGY: [(u8, u8, u8, u8); 11] = [
    (103, 0, 31, 255),
    (178, 24, 43, 255),
    (214, 96, 77, 255),
    (244, 165, 130, 255),
    (253, 219, 199, 255),
    (255, 255, 255, 255),
    (224, 224, 224, 255),
    (186, 186, 186, 255),
    (135, 135, 135, 255),
    (77, 77, 77, 255),
    (26, 26, 26, 255),
];
pub const DIV_RDYLBU: [(u8, u8, u8, u8); 11] = [
    (165, 0, 38, 255),
    (215, 48, 39, 255),
    (244, 109, 67, 255),
    (253, 174, 97, 255),
    (254, 224, 144, 255),
    (255, 255, 191, 255),
    (224, 243, 248, 255),
    (171, 217, 233, 255),
    (116, 173, 209, 255),
    (69, 117, 180, 255),
    (49, 54, 149, 255),
];
pub const DIV_RDYLGN: [(u8, u8, u8, u8); 11] = [
    (165, 0, 38, 255),
    (215, 48, 39, 255),
    (244, 109, 67, 255),
    (253, 174, 97, 255),
    (254, 224, 139, 255),
    (255, 255, 191, 255),
    (217, 239, 139, 255),
    (166, 217, 106, 255),
    (102, 189, 99, 255),
    (26, 152, 80, 255),
    (0, 104, 55, 255),
];
pub const DIV_SPECTRAL: [(u8, u8, u8, u8); 11] = [
    (158, 1, 66, 255),
    (213, 62, 79, 255),
    (244, 109, 67, 255),
    (253, 174, 97, 255),
    (254, 224, 139, 255),
    (255, 255, 191, 255),
    (230, 245, 152, 255),
    (171, 221, 164, 255),
    (102, 194, 165, 255),
    (50, 136, 189, 255),
    (94, 79, 162, 255),
];
pub const DIV_BALANCE: [(u8, u8, u8, u8); 12] = [
    (23, 28, 66, 255),
    (41, 58, 143, 255),
    (11, 102, 189, 255),
    (69, 144, 185, 255),
    (142, 181, 194, 255),
    (210, 216, 219, 255),
    (230, 210, 204, 255),
    (213, 157, 137, 255),
    (196, 101, 72, 255),
    (172, 43, 36, 255),
    (120, 14, 40, 255),
    (60, 9, 17, 255),
];
pub const DIV_DELTA: [(u8, u8, u8, u8); 12] = [
    (16, 31, 63, 255),
    (38, 62, 144, 255),
    (30, 110, 161, 255),
    (60, 154, 171, 255),
    (140, 193, 186, 255),
    (217, 229, 218, 255),
    (239, 226, 156, 255),
    (195, 182, 59, 255),
    (115, 152, 5, 255),
    (34, 120, 36, 255),
    (18, 78, 43, 255),
    (23, 35, 18, 255),
];
pub const DIV_CURL: [(u8, u8, u8, u8); 12] = [
    (20, 29, 67, 255),
    (28, 72, 93, 255),
    (18, 115, 117, 255),
    (63, 156, 129, 255),
    (153, 189, 156, 255),
    (223, 225, 211, 255),
    (241, 218, 206, 255),
    (224, 160, 137, 255),
    (203, 101, 99, 255),
    (164, 54, 96, 255),
    (111, 23, 91, 255),
    (51, 13, 53, 255),
];
pub const DIV_OXY: [(u8, u8, u8, u8); 12] = [
    (63, 5, 5, 255),
    (101, 6, 13, 255),
    (138, 17, 9, 255),
    (96, 95, 95, 255),
    (119, 118, 118, 255),
    (142, 141, 141, 255),
    (166, 166, 165, 255),
    (193, 192, 191, 255),
    (222, 222, 220, 255),
    (239, 248, 90, 255),
    (230, 210, 41, 255),
    (220, 174, 25, 255),
];
pub const DIV_ARMYROSE: [(u8, u8, u8, u8); 7] = [
    (121, 130, 52, 255),
    (163, 173, 98, 255),
    (208, 211, 162, 255),
    (253, 251, 228, 255),
    (240, 198, 195, 255),
    (223, 145, 163, 255),
    (212, 103, 128, 255),
];
pub const DIV_FALL: [(u8, u8, u8, u8); 7] = [
    (61, 89, 65, 255),
    (119, 136, 104, 255),
    (181, 185, 145, 255),
    (246, 237, 189, 255),
    (237, 187, 138, 255),
    (222, 138, 90, 255),
    (202, 86, 44, 255),
];
pub const DIV_GEYSER: [(u8, u8, u8, u8); 7] = [
    (0, 128, 128, 255),
    (112, 164, 148, 255),
    (180, 200, 168, 255),
    (246, 237, 189, 255),
    (237, 187, 138, 255),
    (222, 138, 90, 255),
    (202, 86, 44, 255),
];
pub const DIV_TEMPS: [(u8, u8, u8, u8); 7] = [
    (0, 147, 146, 255),
    (57, 177, 133, 255),
    (156, 203, 134, 255),
    (233, 226, 156, 255),
    (238, 180, 121, 255),
    (232, 132, 113, 255),
    (207, 89, 126, 255),
];
pub const DIV_TEALROSE: [(u8, u8, u8, u8); 7] = [
    (0, 147, 146, 255),
    (114, 170, 161, 255),
    (177, 199, 179, 255),
    (241, 234, 200, 255),
    (229, 185, 173, 255),
    (217, 137, 148, 255),
    (208, 88, 126, 255),
];
pub const DIV_TROPIC: [(u8, u8, u8, u8); 7] = [
    (0, 155, 158, 255),
    (66, 183, 185, 255),
    (167, 211, 212, 255),
    (241, 241, 241, 255),
    (228, 193, 217, 255),
    (214, 145, 193, 255),
    (199, 93, 171, 255),
];
pub const DIV_EARTH: [(u8, u8, u8, u8); 7] = [
    (161, 105, 40, 255),
    (189, 146, 90, 255),
    (214, 189, 141, 255),
    (237, 234, 194, 255),
    (181, 200, 184, 255),
    (121, 167, 172, 255),
    (40, 135, 161, 255),
];
pub const DIV_PICNIC: [(u8, u8, u8, u8); 11] = [
    (0, 0, 255, 255),
    (51, 153, 255, 255),
    (102, 204, 255, 255),
    (153, 204, 255, 255),
    (204, 204, 255, 255),
    (255, 255, 255, 255),
    (255, 204, 255, 255),
    (255, 153, 255, 255),
    (255, 102, 204, 255),
    (255, 102, 102, 255),
    (255, 0, 0, 255),
];
pub const DIV_PORTLAND: [(u8, u8, u8, u8); 5] = [
    (12, 51, 131, 255),
    (10, 136, 186, 255),
    (242, 211, 56, 255),
    (242, 143, 56, 255),
    (217, 30, 30, 255),
];

pub const SEQ_PLOTLY3: [(u8, u8, u8, u8); 13] = [
    (5, 8, 184, 255),
    (25, 16, 216, 255),
    (60, 25, 240, 255),
    (107, 28, 251, 255),
    (152, 28, 253, 255),
    (191, 28, 253, 255),
    (221, 43, 253, 255),
    (242, 70, 254, 255),
    (252, 103, 253, 255),
    (254, 136, 252, 255),
    (254, 165, 253, 255),
    (254, 190, 254, 255),
    (254, 195, 254, 255),
];
pub const SEQ_VIRIDIS: [(u8, u8, u8, u8); 10] = [
    (68, 1, 84, 255),
    (72, 40, 120, 255),
    (62, 73, 137, 255),
    (49, 104, 142, 255),
    (38, 130, 142, 255),
    (31, 158, 137, 255),
    (53, 183, 121, 255),
    (110, 206, 88, 255),
    (181, 222, 43, 255),
    (253, 231, 37, 255),
];
pub const SEQ_CIVIDIS: [(u8, u8, u8, u8); 10] = [
    (0, 34, 78, 255),
    (18, 53, 112, 255),
    (59, 73, 108, 255),
    (87, 93, 109, 255),
    (112, 113, 115, 255),
    (138, 134, 120, 255),
    (165, 156, 116, 255),
    (195, 179, 105, 255),
    (225, 204, 85, 255),
    (254, 232, 56, 255),
];
pub const SEQ_INFERNO: [(u8, u8, u8, u8); 10] = [
    (0, 0, 4, 255),
    (27, 12, 65, 255),
    (74, 12, 107, 255),
    (120, 28, 109, 255),
    (165, 44, 96, 255),
    (207, 68, 70, 255),
    (237, 105, 37, 255),
    (251, 155, 6, 255),
    (247, 209, 61, 255),
    (252, 255, 164, 255),
];
pub const SEQ_MAGMA: [(u8, u8, u8, u8); 10] = [
    (0, 0, 4, 255),
    (24, 15, 61, 255),
    (68, 15, 118, 255),
    (114, 31, 129, 255),
    (158, 47, 127, 255),
    (205, 64, 113, 255),
    (241, 96, 93, 255),
    (253, 150, 104, 255),
    (254, 202, 141, 255),
    (252, 253, 191, 255),
];
pub const SEQ_PLASMA: [(u8, u8, u8, u8); 10] = [
    (13, 8, 135, 255),
    (70, 3, 159, 255),
    (114, 1, 168, 255),
    (156, 23, 158, 255),
    (189, 55, 134, 255),
    (216, 87, 107, 255),
    (237, 121, 83, 255),
    (251, 159, 58, 255),
    (253, 202, 38, 255),
    (240, 249, 33, 255),
];
pub const SEQ_TURBO: [(u8, u8, u8, u8); 15] = [
    (48, 18, 59, 255),
    (65, 69, 171, 255),
    (70, 117, 237, 255),
    (57, 162, 252, 255),
    (27, 207, 212, 255),
    (36, 236, 166, 255),
    (97, 252, 108, 255),
    (164, 252, 59, 255),
    (209, 232, 52, 255),
    (243, 198, 58, 255),
    (254, 155, 45, 255),
    (243, 99, 21, 255),
    (217, 56, 6, 255),
    (177, 25, 1, 255),
    (122, 4, 2, 255),
];
pub const SEQ_BLACKBODY: [(u8, u8, u8, u8); 5] = [
    (0, 0, 0, 255),
    (230, 0, 0, 255),
    (230, 210, 0, 255),
    (255, 255, 255, 255),
    (160, 200, 255, 255),
];
pub const SEQ_BLUERED: [(u8, u8, u8, u8); 2] = [(0, 0, 255, 255), (255, 0, 0, 255)];
pub const SEQ_ELECTRIC: [(u8, u8, u8, u8); 6] = [
    (0, 0, 0, 255),
    (30, 0, 100, 255),
    (120, 0, 100, 255),
    (160, 90, 0, 255),
    (230, 200, 0, 255),
    (255, 250, 220, 255),
];
pub const SEQ_HOT: [(u8, u8, u8, u8); 4] = [
    (0, 0, 0, 255),
    (230, 0, 0, 255),
    (255, 210, 0, 255),
    (255, 255, 255, 255),
];
pub const SEQ_JET: [(u8, u8, u8, u8); 6] = [
    (0, 0, 131, 255),
    (0, 60, 170, 255),
    (5, 255, 255, 255),
    (255, 255, 0, 255),
    (250, 0, 0, 255),
    (128, 0, 0, 255),
];
pub const SEQ_RAINBOW: [(u8, u8, u8, u8); 9] = [
    (150, 0, 90, 255),
    (0, 0, 200, 255),
    (0, 25, 255, 255),
    (0, 152, 255, 255),
    (44, 255, 150, 255),
    (151, 255, 0, 255),
    (255, 234, 0, 255),
    (255, 111, 0, 255),
    (255, 0, 0, 255),
];
pub const SEQ_BLUES: [(u8, u8, u8, u8); 9] = [
    (247, 251, 255, 255),
    (222, 235, 247, 255),
    (198, 219, 239, 255),
    (158, 202, 225, 255),
    (107, 174, 214, 255),
    (66, 146, 198, 255),
    (33, 113, 181, 255),
    (8, 81, 156, 255),
    (8, 48, 107, 255),
];
pub const SEQ_BUGN: [(u8, u8, u8, u8); 9] = [
    (247, 252, 253, 255),
    (229, 245, 249, 255),
    (204, 236, 230, 255),
    (153, 216, 201, 255),
    (102, 194, 164, 255),
    (65, 174, 118, 255),
    (35, 139, 69, 255),
    (0, 109, 44, 255),
    (0, 68, 27, 255),
];
pub const SEQ_BUPU: [(u8, u8, u8, u8); 9] = [
    (247, 252, 253, 255),
    (224, 236, 244, 255),
    (191, 211, 230, 255),
    (158, 188, 218, 255),
    (140, 150, 198, 255),
    (140, 107, 177, 255),
    (136, 65, 157, 255),
    (129, 15, 124, 255),
    (77, 0, 75, 255),
];
pub const SEQ_GNBU: [(u8, u8, u8, u8); 9] = [
    (247, 252, 240, 255),
    (224, 243, 219, 255),
    (204, 235, 197, 255),
    (168, 221, 181, 255),
    (123, 204, 196, 255),
    (78, 179, 211, 255),
    (43, 140, 190, 255),
    (8, 104, 172, 255),
    (8, 64, 129, 255),
];
pub const SEQ_GREENS: [(u8, u8, u8, u8); 9] = [
    (247, 252, 245, 255),
    (229, 245, 224, 255),
    (199, 233, 192, 255),
    (161, 217, 155, 255),
    (116, 196, 118, 255),
    (65, 171, 93, 255),
    (35, 139, 69, 255),
    (0, 109, 44, 255),
    (0, 68, 27, 255),
];
pub const SEQ_GREYS: [(u8, u8, u8, u8); 9] = [
    (255, 255, 255, 255),
    (240, 240, 240, 255),
    (217, 217, 217, 255),
    (189, 189, 189, 255),
    (150, 150, 150, 255),
    (115, 115, 115, 255),
    (82, 82, 82, 255),
    (37, 37, 37, 255),
    (0, 0, 0, 255),
];
pub const SEQ_ORRD: [(u8, u8, u8, u8); 9] = [
    (255, 247, 236, 255),
    (254, 232, 200, 255),
    (253, 212, 158, 255),
    (253, 187, 132, 255),
    (252, 141, 89, 255),
    (239, 101, 72, 255),
    (215, 48, 31, 255),
    (179, 0, 0, 255),
    (127, 0, 0, 255),
];
pub const SEQ_ORANGES: [(u8, u8, u8, u8); 9] = [
    (255, 245, 235, 255),
    (254, 230, 206, 255),
    (253, 208, 162, 255),
    (253, 174, 107, 255),
    (253, 141, 60, 255),
    (241, 105, 19, 255),
    (217, 72, 1, 255),
    (166, 54, 3, 255),
    (127, 39, 4, 255),
];
pub const SEQ_PUBU: [(u8, u8, u8, u8); 9] = [
    (255, 247, 251, 255),
    (236, 231, 242, 255),
    (208, 209, 230, 255),
    (166, 189, 219, 255),
    (116, 169, 207, 255),
    (54, 144, 192, 255),
    (5, 112, 176, 255),
    (4, 90, 141, 255),
    (2, 56, 88, 255),
];
pub const SEQ_PUBUGN: [(u8, u8, u8, u8); 9] = [
    (255, 247, 251, 255),
    (236, 226, 240, 255),
    (208, 209, 230, 255),
    (166, 189, 219, 255),
    (103, 169, 207, 255),
    (54, 144, 192, 255),
    (2, 129, 138, 255),
    (1, 108, 89, 255),
    (1, 70, 54, 255),
];
pub const SEQ_PURD: [(u8, u8, u8, u8); 9] = [
    (247, 244, 249, 255),
    (231, 225, 239, 255),
    (212, 185, 218, 255),
    (201, 148, 199, 255),
    (223, 101, 176, 255),
    (231, 41, 138, 255),
    (206, 18, 86, 255),
    (152, 0, 67, 255),
    (103, 0, 31, 255),
];
pub const SEQ_PURPLES: [(u8, u8, u8, u8); 9] = [
    (252, 251, 253, 255),
    (239, 237, 245, 255),
    (218, 218, 235, 255),
    (188, 189, 220, 255),
    (158, 154, 200, 255),
    (128, 125, 186, 255),
    (106, 81, 163, 255),
    (84, 39, 143, 255),
    (63, 0, 125, 255),
];
pub const SEQ_RDBU: [(u8, u8, u8, u8); 11] = [
    (103, 0, 31, 255),
    (178, 24, 43, 255),
    (214, 96, 77, 255),
    (244, 165, 130, 255),
    (253, 219, 199, 255),
    (247, 247, 247, 255),
    (209, 229, 240, 255),
    (146, 197, 222, 255),
    (67, 147, 195, 255),
    (33, 102, 172, 255),
    (5, 48, 97, 255),
];
pub const SEQ_RDPU: [(u8, u8, u8, u8); 9] = [
    (255, 247, 243, 255),
    (253, 224, 221, 255),
    (252, 197, 192, 255),
    (250, 159, 181, 255),
    (247, 104, 161, 255),
    (221, 52, 151, 255),
    (174, 1, 126, 255),
    (122, 1, 119, 255),
    (73, 0, 106, 255),
];
pub const SEQ_REDS: [(u8, u8, u8, u8); 9] = [
    (255, 245, 240, 255),
    (254, 224, 210, 255),
    (252, 187, 161, 255),
    (252, 146, 114, 255),
    (251, 106, 74, 255),
    (239, 59, 44, 255),
    (203, 24, 29, 255),
    (165, 15, 21, 255),
    (103, 0, 13, 255),
];
pub const SEQ_YLGN: [(u8, u8, u8, u8); 9] = [
    (255, 255, 229, 255),
    (247, 252, 185, 255),
    (217, 240, 163, 255),
    (173, 221, 142, 255),
    (120, 198, 121, 255),
    (65, 171, 93, 255),
    (35, 132, 67, 255),
    (0, 104, 55, 255),
    (0, 69, 41, 255),
];
pub const SEQ_YLGNBU: [(u8, u8, u8, u8); 9] = [
    (255, 255, 217, 255),
    (237, 248, 177, 255),
    (199, 233, 180, 255),
    (127, 205, 187, 255),
    (65, 182, 196, 255),
    (29, 145, 192, 255),
    (34, 94, 168, 255),
    (37, 52, 148, 255),
    (8, 29, 88, 255),
];
pub const SEQ_YLORBR: [(u8, u8, u8, u8); 9] = [
    (255, 255, 229, 255),
    (255, 247, 188, 255),
    (254, 227, 145, 255),
    (254, 196, 79, 255),
    (254, 153, 41, 255),
    (236, 112, 20, 255),
    (204, 76, 2, 255),
    (153, 52, 4, 255),
    (102, 37, 6, 255),
];
pub const SEQ_YLORRD: [(u8, u8, u8, u8); 9] = [
    (255, 255, 204, 255),
    (255, 237, 160, 255),
    (254, 217, 118, 255),
    (254, 178, 76, 255),
    (253, 141, 60, 255),
    (252, 78, 42, 255),
    (227, 26, 28, 255),
    (189, 0, 38, 255),
    (128, 0, 38, 255),
];
pub const SEQ_TURBID: [(u8, u8, u8, u8); 12] = [
    (232, 245, 171, 255),
    (220, 219, 137, 255),
    (209, 193, 107, 255),
    (199, 168, 83, 255),
    (186, 143, 66, 255),
    (170, 121, 60, 255),
    (151, 103, 58, 255),
    (129, 87, 56, 255),
    (104, 72, 53, 255),
    (80, 59, 46, 255),
    (57, 45, 37, 255),
    (34, 30, 27, 255),
];
pub const SEQ_THERMAL: [(u8, u8, u8, u8); 12] = [
    (3, 35, 51, 255),
    (13, 48, 100, 255),
    (53, 50, 155, 255),
    (93, 62, 153, 255),
    (126, 77, 143, 255),
    (158, 89, 135, 255),
    (193, 100, 121, 255),
    (225, 113, 97, 255),
    (246, 139, 69, 255),
    (251, 173, 60, 255),
    (246, 211, 70, 255),
    (231, 250, 90, 255),
];
pub const SEQ_HALINE: [(u8, u8, u8, u8); 12] = [
    (41, 24, 107, 255),
    (42, 35, 160, 255),
    (15, 71, 153, 255),
    (18, 95, 142, 255),
    (38, 116, 137, 255),
    (53, 136, 136, 255),
    (65, 157, 133, 255),
    (81, 178, 124, 255),
    (111, 198, 107, 255),
    (160, 214, 91, 255),
    (212, 225, 112, 255),
    (253, 238, 153, 255),
];
pub const SEQ_SOLAR: [(u8, u8, u8, u8); 12] = [
    (51, 19, 23, 255),
    (79, 28, 33, 255),
    (108, 36, 36, 255),
    (135, 47, 32, 255),
    (157, 66, 25, 255),
    (174, 88, 20, 255),
    (188, 111, 19, 255),
    (199, 137, 22, 255),
    (209, 164, 32, 255),
    (217, 192, 44, 255),
    (222, 222, 59, 255),
    (224, 253, 74, 255),
];
pub const SEQ_ICE: [(u8, u8, u8, u8); 12] = [
    (3, 5, 18, 255),
    (25, 25, 51, 255),
    (44, 42, 87, 255),
    (58, 60, 125, 255),
    (62, 83, 160, 255),
    (62, 109, 178, 255),
    (72, 134, 187, 255),
    (89, 159, 196, 255),
    (114, 184, 205, 255),
    (149, 207, 216, 255),
    (192, 229, 232, 255),
    (234, 252, 253, 255),
];
pub const SEQ_GRAY: [(u8, u8, u8, u8); 12] = [
    (0, 0, 0, 255),
    (16, 16, 16, 255),
    (38, 38, 38, 255),
    (59, 59, 59, 255),
    (81, 80, 80, 255),
    (102, 101, 101, 255),
    (124, 123, 122, 255),
    (146, 146, 145, 255),
    (171, 171, 170, 255),
    (197, 197, 195, 255),
    (224, 224, 223, 255),
    (254, 254, 253, 255),
];
pub const SEQ_DEEP: [(u8, u8, u8, u8); 12] = [
    (253, 253, 204, 255),
    (206, 236, 179, 255),
    (156, 219, 165, 255),
    (111, 201, 163, 255),
    (86, 177, 163, 255),
    (76, 153, 160, 255),
    (68, 130, 155, 255),
    (62, 108, 150, 255),
    (62, 82, 143, 255),
    (64, 60, 115, 255),
    (54, 43, 77, 255),
    (39, 26, 44, 255),
];
pub const SEQ_DENSE: [(u8, u8, u8, u8); 12] = [
    (230, 240, 240, 255),
    (191, 221, 229, 255),
    (156, 201, 226, 255),
    (129, 180, 227, 255),
    (115, 154, 228, 255),
    (117, 127, 221, 255),
    (120, 100, 202, 255),
    (119, 74, 175, 255),
    (113, 50, 141, 255),
    (100, 31, 104, 255),
    (80, 20, 66, 255),
    (54, 14, 36, 255),
];
pub const SEQ_ALGAE: [(u8, u8, u8, u8); 12] = [
    (214, 249, 207, 255),
    (186, 228, 174, 255),
    (156, 209, 143, 255),
    (124, 191, 115, 255),
    (85, 174, 91, 255),
    (37, 157, 81, 255),
    (7, 138, 78, 255),
    (13, 117, 71, 255),
    (23, 95, 61, 255),
    (25, 75, 49, 255),
    (23, 55, 35, 255),
    (17, 36, 20, 255),
];
pub const SEQ_MATTER: [(u8, u8, u8, u8); 12] = [
    (253, 237, 176, 255),
    (250, 205, 145, 255),
    (246, 173, 119, 255),
    (240, 142, 98, 255),
    (231, 109, 84, 255),
    (216, 80, 83, 255),
    (195, 56, 90, 255),
    (168, 40, 96, 255),
    (138, 29, 99, 255),
    (107, 24, 93, 255),
    (76, 21, 80, 255),
    (47, 15, 61, 255),
];
pub const SEQ_SPEED: [(u8, u8, u8, u8); 12] = [
    (254, 252, 205, 255),
    (239, 225, 156, 255),
    (221, 201, 106, 255),
    (194, 182, 59, 255),
    (157, 167, 21, 255),
    (116, 153, 5, 255),
    (75, 138, 20, 255),
    (35, 121, 36, 255),
    (11, 100, 44, 255),
    (18, 78, 43, 255),
    (25, 56, 34, 255),
    (23, 35, 18, 255),
];
pub const SEQ_AMP: [(u8, u8, u8, u8); 12] = [
    (241, 236, 236, 255),
    (230, 209, 203, 255),
    (221, 182, 170, 255),
    (213, 156, 137, 255),
    (205, 129, 103, 255),
    (196, 102, 73, 255),
    (186, 74, 47, 255),
    (172, 44, 36, 255),
    (149, 19, 39, 255),
    (120, 14, 40, 255),
    (89, 13, 31, 255),
    (60, 9, 17, 255),
];
pub const SEQ_TEMPO: [(u8, u8, u8, u8); 12] = [
    (254, 245, 244, 255),
    (222, 224, 210, 255),
    (189, 206, 181, 255),
    (153, 189, 156, 255),
    (110, 173, 138, 255),
    (65, 157, 129, 255),
    (25, 137, 125, 255),
    (18, 116, 117, 255),
    (25, 94, 106, 255),
    (28, 72, 93, 255),
    (25, 51, 80, 255),
    (20, 29, 67, 255),
];
pub const SEQ_BURG: [(u8, u8, u8, u8); 7] = [
    (255, 198, 196, 255),
    (244, 163, 168, 255),
    (227, 129, 145, 255),
    (204, 96, 125, 255),
    (173, 70, 108, 255),
    (139, 48, 88, 255),
    (103, 32, 68, 255),
];
pub const SEQ_BURGYL: [(u8, u8, u8, u8); 7] = [
    (251, 230, 197, 255),
    (245, 186, 152, 255),
    (238, 138, 130, 255),
    (220, 113, 118, 255),
    (200, 88, 108, 255),
    (156, 63, 93, 255),
    (112, 40, 74, 255),
];
pub const SEQ_REDOR: [(u8, u8, u8, u8); 7] = [
    (246, 210, 169, 255),
    (245, 183, 142, 255),
    (241, 156, 124, 255),
    (234, 129, 113, 255),
    (221, 104, 108, 255),
    (202, 82, 104, 255),
    (177, 63, 100, 255),
];
pub const SEQ_ORYEL: [(u8, u8, u8, u8); 7] = [
    (236, 218, 154, 255),
    (239, 196, 126, 255),
    (243, 173, 106, 255),
    (247, 148, 93, 255),
    (249, 123, 87, 255),
    (246, 99, 86, 255),
    (238, 77, 90, 255),
];
pub const SEQ_PEACH: [(u8, u8, u8, u8); 7] = [
    (253, 224, 197, 255),
    (250, 203, 166, 255),
    (248, 181, 139, 255),
    (245, 158, 114, 255),
    (242, 133, 93, 255),
    (239, 106, 76, 255),
    (235, 74, 64, 255),
];
pub const SEQ_PINKYL: [(u8, u8, u8, u8); 7] = [
    (254, 246, 181, 255),
    (255, 221, 154, 255),
    (255, 194, 133, 255),
    (255, 166, 121, 255),
    (250, 138, 118, 255),
    (241, 109, 122, 255),
    (225, 83, 131, 255),
];
pub const SEQ_MINT: [(u8, u8, u8, u8); 7] = [
    (228, 241, 225, 255),
    (180, 217, 204, 255),
    (137, 192, 182, 255),
    (99, 166, 160, 255),
    (68, 140, 138, 255),
    (40, 114, 116, 255),
    (13, 88, 95, 255),
];
pub const SEQ_BLUGRN: [(u8, u8, u8, u8); 7] = [
    (196, 230, 195, 255),
    (150, 210, 164, 255),
    (109, 188, 144, 255),
    (77, 162, 132, 255),
    (54, 135, 122, 255),
    (38, 107, 110, 255),
    (29, 79, 96, 255),
];
pub const SEQ_DARKMINT: [(u8, u8, u8, u8); 7] = [
    (210, 251, 212, 255),
    (165, 219, 194, 255),
    (123, 188, 176, 255),
    (85, 156, 158, 255),
    (58, 124, 137, 255),
    (35, 93, 114, 255),
    (18, 63, 90, 255),
];
pub const SEQ_EMRLD: [(u8, u8, u8, u8); 7] = [
    (211, 242, 163, 255),
    (151, 225, 150, 255),
    (108, 192, 139, 255),
    (76, 155, 130, 255),
    (33, 122, 121, 255),
    (16, 89, 101, 255),
    (7, 64, 80, 255),
];
pub const SEQ_AGGRNYL: [(u8, u8, u8, u8); 7] = [
    (36, 86, 104, 255),
    (15, 114, 121, 255),
    (13, 143, 129, 255),
    (57, 171, 126, 255),
    (110, 197, 116, 255),
    (169, 220, 103, 255),
    (237, 239, 93, 255),
];
pub const SEQ_BLUYL: [(u8, u8, u8, u8); 7] = [
    (247, 254, 174, 255),
    (183, 230, 165, 255),
    (124, 203, 162, 255),
    (70, 174, 160, 255),
    (8, 144, 153, 255),
    (0, 113, 139, 255),
    (4, 82, 117, 255),
];
pub const SEQ_TEAL: [(u8, u8, u8, u8); 7] = [
    (209, 238, 234, 255),
    (168, 219, 217, 255),
    (133, 196, 201, 255),
    (104, 171, 184, 255),
    (79, 144, 166, 255),
    (59, 115, 143, 255),
    (42, 86, 116, 255),
];
pub const SEQ_TEALGRN: [(u8, u8, u8, u8); 7] = [
    (176, 242, 188, 255),
    (137, 232, 172, 255),
    (103, 219, 165, 255),
    (76, 200, 163, 255),
    (56, 178, 163, 255),
    (44, 152, 160, 255),
    (37, 125, 152, 255),
];
pub const SEQ_PURP: [(u8, u8, u8, u8); 7] = [
    (243, 224, 247, 255),
    (228, 199, 241, 255),
    (209, 175, 232, 255),
    (185, 152, 221, 255),
    (159, 130, 206, 255),
    (130, 109, 186, 255),
    (99, 88, 159, 255),
];
pub const SEQ_PURPOR: [(u8, u8, u8, u8); 7] = [
    (249, 221, 218, 255),
    (242, 185, 196, 255),
    (229, 151, 185, 255),
    (206, 120, 179, 255),
    (173, 95, 173, 255),
    (131, 75, 160, 255),
    (87, 59, 136, 255),
];
pub const SEQ_SUNSET: [(u8, u8, u8, u8); 7] = [
    (243, 231, 155, 255),
    (250, 196, 132, 255),
    (248, 160, 126, 255),
    (235, 127, 134, 255),
    (206, 102, 147, 255),
    (160, 89, 160, 255),
    (92, 83, 165, 255),
];
pub const SEQ_MAGENTA: [(u8, u8, u8, u8); 7] = [
    (243, 203, 211, 255),
    (234, 169, 189, 255),
    (221, 136, 172, 255),
    (202, 105, 157, 255),
    (177, 77, 142, 255),
    (145, 53, 125, 255),
    (108, 33, 103, 255),
];
pub const SEQ_SUNSETDARK: [(u8, u8, u8, u8); 7] = [
    (252, 222, 156, 255),
    (250, 164, 118, 255),
    (240, 116, 110, 255),
    (227, 79, 111, 255),
    (220, 57, 119, 255),
    (185, 37, 122, 255),
    (124, 29, 111, 255),
];
pub const SEQ_AGSUNSET: [(u8, u8, u8, u8); 7] = [
    (75, 41, 145, 255),
    (135, 44, 162, 255),
    (192, 54, 157, 255),
    (234, 79, 136, 255),
    (250, 120, 118, 255),
    (246, 169, 122, 255),
    (237, 217, 163, 255),
];
pub const SEQ_BRWNYL: [(u8, u8, u8, u8); 7] = [
    (237, 229, 207, 255),
    (224, 194, 162, 255),
    (211, 156, 131, 255),
    (193, 118, 111, 255),
    (166, 84, 97, 255),
    (129, 55, 83, 255),
    (84, 31, 63, 255),
];

#[cfg(test)]
mod tests {
    use std::str::FromStr;

    #[allow(unused_imports)]
    use super::*;
    #[allow(unused_imports)]
    use pretty_assertions::{assert_eq, assert_ne, assert_str_eq};
    use strum::{IntoEnumIterator, VariantNames};

    #[cfg_attr(feature = "strum", test)]
    fn test_strum() {
        assert_eq!(Numerical::from_repr(0).unwrap(), Numerical::Ratio);
        assert_eq!(Numerical::from_str("Ratio").unwrap(), Numerical::Ratio);
        assert_eq!("Ratio", format!("{}", Numerical::Ratio));
        assert_eq!(
            Numerical::VARIANTS.to_vec(),
            Numerical::iter()
                .map(|v| format!("{}", v))
                .collect::<Vec<_>>()
        );
    }
}
